# Learning  interfacing with hal and QT
#
# Anders Haldin  Fab academy 06/05/2015
#
# licenece MIT
#

import sys, serial,time,os
from PyQt4 import QtGui, QtCore

port = '/dev/ttyUSB0' 
# open serial port
#
conn = serial.Serial('/dev/ttyUSB0', 9600) # stores serial and baud rate
conn.setDTR() #Sets or clears the DTR (Data Terminal Ready) bit in the UART, if supported by the underlying implementation.
#byte=port.read(size=1)


class Example(QtGui.QWidget):
    
    def __init__(self):
        super(Example, self).__init__()
        
        self.initUI()
        
    def initUI(self):
#
# Show image DOES NOT WORK.
#
        pic = QtGui.QLabel(self)
        pic.setGeometry(10, 10, 400, 100)
        #use full ABSOLUTE path to the image, not relative
        pic.setPixmap(QtGui.QPixmap(os.getcwd() + "/home/bah/fab_academy_work/14_week/interface/zen2.gif"))

#
# 2 buttons
#
        QtGui.QToolTip.setFont(QtGui.QFont('SansSerif', 10))
        
        self.setToolTip('<b>Nothing</b> to see over here...') # tto  tip on background
        
        btnB = QtGui.QPushButton('c', self)
        btnB.setToolTip('Do you want to take <b> blue pill?</b> or...') # tool tip on buttton
        btnB.resize(btnB.sizeHint())
        btnB.move(200, 50)
        btnB.clicked.connect(self.sendC)  # on button press call function sendC that writes letter c      
        
        btnR = QtGui.QPushButton('exit', self)
        btnR.setToolTip('Do you want to take <b>red pill?</b> or...') # tool tip on buttton
        btnR.resize(btnR.sizeHint())
        btnR.move(300, 50)
        btnR.clicked.connect(self.close)  # quits program links to closeEvent.    
  

#
#fields
#
        title = QtGui.QLabel('Title')
        titleEdit = QtGui.QLineEdit()

        grid = QtGui.QGridLayout()
        grid.setSpacing(25)

        grid.addWidget(title, 1, 0)
        grid.addWidget(titleEdit, 1, 1)

#
# number Box for input
#
        lcd = QtGui.QLCDNumber(self) 

        vbox = QtGui.QVBoxLayout()
        vbox.addWidget(lcd) 

       # self.setLayout(vbox)

        
        self.setLayout(grid) 
        self.resize(650, 250) #window size
        self.center() 
        self.setWindowTitle('Center')
        self.show()


#
# Draw ellipse
#
    def paintEvent(self, e):

        qp = QtGui.QPainter()
        qp.begin(self)
        self.drawRectangles(qp)
        qp.end()
        
    def drawRectangles(self, qp):
      
        color = QtGui.QColor(0, 0, 0)
        color.setNamedColor('#d4d4d4')
        qp.setPen(color)

        qp.setBrush(QtGui.QColor(0, 0, 0))
        qp.drawEllipse(200, 150, 60, 60)

        qp.setBrush(QtGui.QColor(0, 0, 0))
        qp.drawEllipse(350, 150, 60, 60)


    def closeEvent(self, event): # links to the x in top corner... not in to the button I previously created.
        
        reply = QtGui.QMessageBox.question(self, 'Message',
            "Are you sure to quit?", QtGui.QMessageBox.Yes | 
            QtGui.QMessageBox.No, QtGui.QMessageBox.No)

        if reply == QtGui.QMessageBox.Yes:
            event.accept()
        else:
            event.ignore()    

	
    def sendC(self): # write letter c to the defined serial port 
    	conn.write('c')


    def center(self): #enter a window on the desktop screen
        
        qr = self.frameGeometry()
        cp = QtGui.QDesktopWidget().availableGeometry().center()
        qr.moveCenter(cp)
   
        self.move(qr.topLeft()) 
     
def main():
    
    app = QtGui.QApplication(sys.argv)
    ex = Example()
    sys.exit(app.exec_())

if __name__ == '__main__':
    main()
